/**
 * 񓯊\bh translate PointNXłB
 */
public class AsyncPoint {
	/**
	 * XWB
	 */
	public int x;
	/**
	 * YWB
	 */
	public int y;
	
	/**
	 * RXgN^B
	 */
	public AsyncPoint() {
		this(0, 0);
	}
	
	public AsyncPoint(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	/**
	 * ړ܂B
	 * @param dx Xړ
	 * @param dy Yړ
	 */
	public void translate(int dx, int dy) {
		Thread thread = new TranslateThread(dx, dy);
		thread.start();
	}
	
	@Override
	public String toString() {
		synchronized(this) {
			return "AsyncPoint(" + this.x + "," + this.y + ")";
		}
	}
	
	/**
	 * ړ񓯊Ɏs邽߂̓NXłB
	 */
	private class TranslateThread extends Thread {
		/**
		 * XړʁB
		 */
		private int dx;
		/**
		 * YړʁB
		 */
		private int dy;
		
		/**
		 * RXgN^B
		 * @param dx Xړ
		 * @param dy Yړ
		 */
		public TranslateThread(int dx, int dy) {
			this.dx = dx;
			this.dy = dy;
		}
		
		@Override
		public void run() {
			synchronized(AsyncPoint.this) {
				AsyncPoint.this.x += dx;
				AsyncPoint.this.y += dy;
			}
		}
	}
}
